function[K,F]=Cremat1D(X,T,f)
% [K,F]=Cremat1D(X,T)
% Genera la matriz de rigidez o conductividad K y 
% la matriz F de los trminos independientes (fuente)
% para la ecuacion U_xx+U=f(x), con condiciones de frontera Dirichlet
% X= vector columna con coordenadas nodales
% T= matriz de topologa o conectividad
% f es la variable que representa el trmino fuente del problema, es una cadena de caracteres 
% con el nombre de la  funcin declarada previamente, en la que se evalua f(x)

 % Numero de puntos de Gauss. (para la cuadratura)
 ngaus=2;
 %Determinacion de la cuadratura 
 [pospg,pespg]=Cuadratura1D(ngaus);
 % pospg= vector columna conteniendo las coordenadas de los puntos Gauss
 % pespg=vector fila conteniendo los pesos de los puntos de Gauss
 % Determinacion de las funciones de forma
 [N,Nxi]=Funcforma(pospg,pespg);
 % Numero de elementos y numero de nodos en cada elemento
[nelem,nnode]=size(T);
% numero total de nodos en la malla
npoin=size(X,1);
% Dimensionamiento de la matriz Ke en el elemento omega e
K=zeros(npoin,npoin);
F=zeros(npoin,1);
% Bucle en los elementos
for ielem=1:nelem
    Te=T(ielem,:);
    Xe=X(Te);
    [Ke,Fe]=MatE1(Xe,nnode,pospg,pespg,N,Nxi);
   % break
    K(Te,Te)=K(Te,Te)+Ke;
    F(Te)=F(Te)+Fe;
    clear Ke; clear fe;
end
F=-F;

 
 
