function[K]=MatRigidez1D_Difusivo(X,T,D,alfa,x0)
% [K]=MatRigidez1D_Difusivo(X,T,D)
% Genera la matriz de rigidez o conductividad K en 1D con
% coeficiente difusivo D. Kij=int(DdU'V') 
% para la ecuacion DU_xx+CUx=f(x).
% X= vector columna con coordenadas nodales
% T= matriz de topologa o conectividad
% D es el coeficiente difusivo, es una funcion declarada previamente 

%--------- Rodolfo Gallo agosto 2010

% Numero de puntos de Gauss. (para la cuadratura)
ngaus=2;
%Determinacion de la cuadratura 
[pospg,pespg]=Cuadratura1D(ngaus);
% pospg= vector columna conteniendo las coordenadas de los puntos Gauss
% pespg=vector fila conteniendo los pesos de los puntos de Gauss
% Determinacion de las funciones de forma
[N,Nxi]=Funcforma(pospg);
% Numero de elementos y numero de nodos en cada elemento
[nelem,nnode]=size(T);
% numero total de nodos en la malla
npoin=size(X,1);
% Dimensionamiento de la matriz Ke en el elemento omega e
K=zeros(npoin,npoin);
% Bucle en los elementos
for ielem=1:nelem
    Te=T(ielem,:);
    Xe=X(Te);
    Ke=MatRigidezEl1D_Difusivo(Xe,nnode,pospg,pespg,Nxi,N,D,alfa,x0);
   % break
    K(Te,Te)=K(Te,Te)+Ke;
    clear Ke; 
end
