function[Ke]=MatRigidezEl1D_Difusivo(Xe,nnode,pospg,pespg,Nxi,N,D,alfa,x0)
%Ke=Matriz de rigidez/conductividad elemental, con coeficiente difusivo
%Xe=[x_k
%    x_k+1],cordenadas de los nodos del elemento omegak .
%nnode=numro de nodos del elemento
%pospg,pespg coordendas y pesos de los puntos de gaus
% en el elemento de referencia
%N=[varfi1,varfi2], funciones de forma (con coordenadas en el elemento de referencia)
%Nxi derivada de N
% D es el coeficiente de difusin
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Ke=zeros(nnode,nnode);
%nmero de puntos de gaus
ngaus=size(pospg,1);
% Bucle en puntos de Gauss
for igaus=1:ngaus
    Ni=N(igaus,:);
    Nxi_igaus=Nxi(igaus,:);
    jacob=Nxi_igaus*Xe;
    dvolu=pespg(igaus)*jacob;
    Nx=Nxi_igaus/jacob;
    Difusivo=feval(D,Ni*Xe,alfa,x0);
    Ke=Ke+(Nx'*Nx)* Difusivo*dvolu;
end