% Programa principal 
% Resolucin de la ecuacin de Poisson en 1D
% U_xx=f(x)
% Con condiciones de frontera Dirichlet

%%% CONSTRUCCIN DE LA MALLA
%_______________________________________________________
% a=[]; b=[];
% while isempty(a)==1
% a=input('introduzca el valor del extremo izquierdo del intervalo. a=');
% end
% while isempty(b)==1
% b=input('introduzca el valor del extremo derecho del intervalo. b=');
% end
a=0;
b=1;
alfa=250;
x0=0.75;
[X,T,Front]=Creamalla1D(a,b); % Crea la malla 
%_________________________________________________________________________
%%% CREA LA MATRIZ K DEL SISTEMA ( matriz de rigidez) Y EL VECTOR F DE
%%% CARGA
%_________________________________________________________________________
K=MatRigidez1D_Difusivo(X,T,'CoefDifusivo',alfa,x0);
%K=K;
F=VectorCarga1D_Difusivo(X,T,'fuente',alfa,x0);
%_________________________________________________________________________
%%% CREA LA MATRIZ G DEL SISTEMA DE CONDICIONES DE FRONTERA Ga=g;
%_________________________________________________________________________
% Matriz con los nodos en la frontera de Dirichlet y el valor prescrito
% Numero de condiciones de frontera
ncondfron=size(Front,1);
% numero de nodos de la malla
nnode=size(X,1);
C=[1 0
   nnode 0];
% Numero de ecuaciones del sitema
neq=size(F,1);
% Matriz G del sistema Ga=g con las condiciones de frontera de Dirichlet
G=zeros(ncondfron,neq);
G(:,C(:,1))=eye(ncondfron);
%_________________________________________________________________________
%%% ENSAMBLE DE LAS CONDICIONES DE FRONTERA DICHLET EN LA MATRIZ K 
Ktot=[K,G';G zeros(ncondfron,ncondfron)]; % matriz total del sistema
%_________________________________________________________________________
%%% ENSAMBLE DE LAS CONDICIONES DE FRONTERA DICHLET EN LA MATRIZ F
%_________________________________________________________________________
b=C(:,2);% Matriz del termino independiente de las condiciones frontera.
Ftotal=[F;b]; 
%_________________________________________________________________________
%%% SOLUCIN DEL SISTEMA
Sol=Ktot\Ftotal;
Sol=Sol(1:neq);

%_________________________________________________________________________
%%% POSTPROCESO
% sol exacta del problema
x=0:0.01:1;
Exact1=(1-x).*(atan(alfa*(x-x0))+atan(alfa*x0));
figure(1)
plot(x,Exact1)
hold on
plot(X,Sol,'r*')
% solucion exacta evaluada en los nodos de la malla
Exact2=(1-X).*(atan(alfa*(X-x0))+atan(alfa*x0));
error=Exact2-Sol;
% norma energtica 
NormEnerg=sqrt(error'*K*error)
% Norma L2
NormL2=NormaL2(X,T,Sol,alfa,x0)
% H=[1/8,1/16,1/24,1/32,1/100,1/200,1/300,1/400];
% ErrorL2=[0.1133,0.0738,0.0543,0.0421,0.0098,0.0024,0.0009,0.0005];
% ErorEner=[0.6631,0.4727,0.3617,0.2886,0.0684,0.0133,0.0070,0.0047];
% xx=log(H);
% yyy=log(ErrorL2);
% yy=log(ErorEner);
% loglog(xx,yy,'-*b',xx,yyy,'-*r')
%_________________________________________________________________________




 

 

