function[F]=VectorCarga1D_Difusivo(X,T,f,alfa,x0)
% [K]=VectorCarga1D(X,T,f)
% Genera el vector de carga F en 1D F=int(fv)
% para la ecuacion U_xx=f(x)
% X= vector columna con coordenadas nodales
% T= matriz de topologa o conectividad
% f es la variable que representa el trmino fuente del problema, es una cadena de caracteres 
% con el nombre de la  funcin declarada previamente, en la que se evalua f(x)

%--------- Rodolfo Gallo agosto 2010
 % Numero de puntos de Gauss. (para la cuadratura)
 ngaus=2;
 %Determinacion de la cuadratura 
 [pospg,pespg]=Cuadratura1D(ngaus);
 % pospg= vector columna conteniendo las coordenadas de los puntos Gauss
 % pespg=vector fila conteniendo los pesos de los puntos de Gauss
 % Determinacion de las funciones de forma
 [N,Nxi]=Funcforma(pospg);
 % Numero de elementos y numero de nodos en cada elemento
[nelem,nnode]=size(T);
% numero total de nodos en la malla
npoin=size(X,1);
% Dimensionamiento de la matriz F 
F=zeros(npoin,1);
% Bucle en los elementos
for ielem=1:nelem
    Te=T(ielem,:);
    Xe=X(Te);
    Fe=VectorCargaEl1D_Difusivo(Xe,nnode,pospg,pespg,N,Nxi,f,alfa,x0);
    F(Te)=F(Te)+Fe;
    clear fe;
end