function[Fe]=VectorCargaEl1D_Difusivo(Xe,nnode,pospg,pespg,N,Nxi,f,alfa,x0)
%[Fe]=VectorCargaEl1D(Xe,nnode,pospg,pespg,N,Nxi,f)
% Calcuala el vector de carga elemental en 1D Fe=int(fv)
% para la ecuacion U_xx=f(x)
%Xe=[x_k,x_k+1],cordenadas de los nodos del elemento omegak .
%nnode=numro de nodos del elemento
%pospg,pespg coordendas y pesos de los puntos de gaus
% en el elemento de referencia
%N=[varfi1,varfi2], funciones de forma (con coordenadas en el elemento de referencia)
%Nxi derivada de N
% f es la variable que representa el trmino fuente del problema, es una cadena de caracteres 
% con el nombre de la  funcin declarada previamente, en la que se evalua f(x)

%--------- Rodolfo Gallo agosto 2010
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Dimensionamiento del vector elemental Fe
Fe=zeros(nnode,1);
%nmero de puntos de gaus
ngaus=size(pospg,1);
% Bucle en puntos de Gauss
for igaus=1:ngaus
    Ni=N(igaus,:);
    Nxi_igaus=Nxi(igaus,:);
    jacob=Nxi_igaus*Xe;
    dvolu=pespg(igaus)*jacob;
    %f_igaus=fuente(pospg(igaus));
    f_igaus=feval(f,Ni*Xe,alfa,x0);
    Fe=Fe+Ni'*(f_igaus*dvolu);
end