function [X,T,Front] = CreaMallaCuadrilatero(x1,x2,y1,y2,nx,ny)
% [X,T] = CreaMallaCuadrilatero(x1,x2,y1,y2,nx,ny)
% Crea la topologia de una malla estructurada de Cuadrilateros
% en un dominio rectangular [x1,x2]x[y1,y2]
% nx,ny: nmero de divisiones en cada direccin
%%%%%%    Rodolfo Gallo Enero 2010
  X = zeros((nx+1)*(ny+1),2);
  T = zeros(2*nx*ny,3);

  hx = (x2-x1)/nx;
  hy = (y2-y1)/ny;

  xs = [x1:hx:x2]';
  unos = ones(nx+1,1);

% Coordenadas de los nodos
  for i = 1:ny+1,
    ys = ((i-1)*hy+y1)*unos;
    posi = [(i-1)*(nx+1)+1:i*(nx+1)]; 
    X(posi,:)=[xs,ys];
  end

% Conectividades
  for i = 1:ny,
     for j = 1:nx,
       ielem = (i-1)*2*nx+2*j;
       inode = (i-1)*(nx+1)+j;
       T(ielem-1,:) = [ inode inode+(nx+2) inode+(nx+1)];
       T(ielem,:) = [ inode inode+1 inode+(nx+2)]; 
     end
  end
  
  F1=1:nx+1;
  F2=2*(nx+1):nx+1:(nx+1)*(ny+1);
  F3=(nx+1)*(ny+1)-1:-1:(nx+1)*(ny+1)-nx;
  F4=(nx+1)*(ny+1)-2*nx-1:-(nx+1):nx+1;
  Front=[F1';F2';F3';F4'];