%programa para modificar la salida de Ez4u y tener
%la matrices: X de coordenadas de los nodos, T la topologia y F la matriz
%con los nodos en la frontera.
%para usar con MATLAB
%------------------Rodolfo Gallo----------octubre  2010-------------
function[X,T,F]=Modificar_rodolfo(file,nf)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%% ENTRADAS %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                                                                         %
% -file es un archivo .dcm generado por Ez4u con informacion de la malla  %
%   se debe ingresar file como una cadena de caracteres. Por ejemplo      %
%   'malla.inp'                                                           %
% - nf es el numero en que se ha dividido la frontera,                      %
%  - no reconoce bien los nodos en la frontera. Por lo tanto colocar nf=0.                                                                        %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%% SALIDAS %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                                                                         %
% -X matriz con los nodos del mallado                                     %
% -T matriz de topologa                                                  %
% -F matriz con los nodos en la frontera.                                 %
%                                                                         %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
X=[];T=[]; F=[]; nodof=[]; 

% Formatos: d entero, f real, c caracter, s texto, b binario, h
% hexadecimal, e cientifica

[fi1,texto]=fopen(file,'r+'); %fi1 sera el identificador del archivo file.inp
fseek(fi1,0,-1); % me coloco al inicio del archivo
com=fgetl(fi1);  % leo la primer linea y se almacena  en caracteres
dimen=sscanf(com,'%d'); %llevo  la linea anterior a formato numerico

% En este ciclo se genera la matriz X
for j=1:dimen(1)  
   car=fgetl(fi1); % leo la siguiente linea y se almacena en caracteres
   X1=sscanf(car,'%d %f %f %d %d'); %ahora estan en formato numerico
   X=[X; X1(1:3)'];
end

% Ahora se genera la matriz de topologia T
fseek(fi1,1,0);  
for j=1:dimen(2)
   car=fgetl(fi1); %se almacena la primer linea de la topologia, en caracteres
   dimen1=sscanf(car,'%d'); %llevo  la linea anterior a formato numerico
   T=[T; dimen1'];
end
T=[T(:,1),T(:,8:end)];

% Se genera los nodos de la frontera
if nf~=0
   for k=1:nf
       car=fgetl(fi1); %se almacena la primer linea de la topologia, en caracteres
       dimen1=sscanf(car,'%d'); %llevo  la linea anterior a formato numerico
       for j=1:dimen1(end-1)
           car=fgetl(fi1); %se almacena la primer linea de la topologia, en caracteres
           dimen2=sscanf(car,'%d'); %llevo  la linea anterior a formato numerico
           %F=[F;dimen2(1)];
           F(k,j)=dimen2(1);
       end
       nodof=[nodof;dimen1(end-1)];
   end
   F=[[1:nf]',nodof,F]; % Matriz con los nodos en la frontera. Cada fila es un frontera...
   % la primer columna son la fronteras, la segunda el nmero de nodos y las
   % demas los nodos 
   fclose(fi1); %cierro el archivo con identificador fi1

   % Ordenando los nodos de la frontera
   for j=1:2
       I=F(j,3:F(j,2)+2);
       NF=X(I,:);
       [Y,P]=sort(NF(:,3));
       F(j,3:F(j,2)+2)=I(P);
   end

   I=F(3,3:F(3,2)+2);
   NF=X(I,:);
   [Y,P]=sort(NF(:,2));
   F(3,3:F(3,2)+2)=I(P);

   I=F(4,3:F(4,2)+2);
   NF=X(I,:);
   [Y,P]=sort(NF(:,3));
   F(4,3:F(4,2)+2)=I(P);

   I=F(5,3:F(5,2)+2);
   NF=X(I,:);
   [Y,P]=sort(NF(:,2),'descend');
   F(5,3:F(5,2)+2)=I(P);

   I=F(6,3:F(6,2)+2);
   NF=X(I,:);
   [Y,P]=sort(NF(:,3),'descend');
   F(6,3:F(6,2)+2)=I(P);

   I=F(7,3:F(7,2)+2);
   NF=X(I,:);
   [Y,P]=sort(NF(:,2));
   F(7,3:F(7,2)+2)=I(P);
end
% Hasta aqui se gener la frontera

X=X(:,2:3);
T=T(:,2:5);

% save malla X T F


