% PROGRAMA PRINCIPAL 
% Resolucion de la ecuacion del calor 
%     -u_xx- u_yy = f en [-a,b]X[-a,b] = [-1,1]X[-1,1]
% con condiciones de contorno Dirichlet en todo el contorno. 
% Rodolfo Gallo

%-----------------GENERACION DE LA MALLA ------------------------  

x1=0;  x2=1; y1=0; y2=1; nx=40; ny=40;
[X,T,Front] = CreaMalla(x1,x2,y1,y2,nx,ny);
%_________________________________________________________________________
%%% CREA LA MATRIZ K DEL SISTEMA ( matriz de rigidez) Y EL VECTOR F DE
%%% CARGA
%_________________________________________________________________________
Krigidez=MatrizRigidezCuadrilatero(X,T);
K=Krigidez; % matriz del sistema
f='fuente';
F=VectorCargaCuadrilatero(X,T); 
%_________________________________________________________________________

%_________________________________________________________________________
%%% CREA LA MATRIZ G DEL SISTEMA DE CONDICIONES DE FRONTERA Ga=g;
%_________________________________________________________________________
% Numero de condiciones de frontera
ncondfron=size(Front,1);
% Matriz con los nodos en la frontera de Dirichlet y el valor prescrito
 Xfron=X(Front,:);
 Vfron=SolExacta(Xfron);
 C=[Front,Vfron];
% Numero de ecuaciones del sitema
neq=size(F,1);
% Matriz G del sistema Ga=g con las condiciones de frontera de Dirichlet
G=zeros(ncondfron,neq);
G(:,C(:,1))=eye(ncondfron);
%_________________________________________________________________________
%_________________________________________________________________________
%%% ENSAMBLE DE LAS CONDICIONES DE FRONTERA DICHLET EN LA MATRIZ K 
Ktot=[K,G';G zeros(ncondfron,ncondfron)]; % matriz total del sistema
%_________________________________________________________________________
%%% ENSAMBLE DE LAS CONDICIONES DE FRONTERA DICHLET EN LA MATRIZ F
%_________________________________________________________________________
b=C(:,2);% Matriz del termino independiente de las condiciones frontera.
Ftotal=[F;b]; 
%_________________________________________________________________________
%%% SOLUCIN DEL SISTEMA
Sol=Ktot\Ftotal;
Sol=Sol(1:neq);
% POSTPROCESO: _______________________________
%  
%pause
%%% POSTPROCESO
% Dibujo de la temperatura (campo escalar)
  figure(1)
  clf
  DibujaSol(X,T,Sol)
  title('Solucin calculada con EF');
  color = caxis; 
  escala(color,2)

% Solucion sol exacta
  figure(2)
 SolExac=SolExacta(X);
  %exacta=(x.^2-1).*(y.^2-1).*sin(x.^2+y.^2-0.5);
  DibujaSol(X,T,SolExac)
  title('Solucin exacta');
  error=SolExac-Sol;
  norm_infError = max(abs(error))
  normEner=sqrt(error'*K*error)
  
  % Graficas en superficies:
  figure(3)
  tri=delaunay(X(:,1),X(:,2));
  trisurf(tri,X(:,1),X(:,2),SolExac);
  title('Solucin analtica');

  figure(4)
  tri=delaunay(X(:,1),X(:,2));
  trisurf(tri,X(:,1),X(:,2),Sol);
  title('Solucin calculada con EF');
 
  