function [F] = VectorCargaCuadrilatero(X,T) 
% [K,f] = Cremat(X,T,pospg,pespg,N,Nxi,Neta) 
% Matriz de rigidez/conductividad K y trmino independiente f (fuente) 
% para la ecuacin del calor en 2D 
% 
% X:            coordenadas nodales 
% T:            conectividades (elementos) 
% pospg, pespg: posicin y pesos de los puntos de Gauss en el 
%               elemento de referencia 
% N,Nxi,Neta:   funciones de forma y derivadas con coordenadas locales 
%               en los puntos de Gauss del elemento de referencia 
%%%%%%    Giovanni Caldern Materia: MEF  A-2007  
 

% numero de elementos y numero de nodos en cada elemento 
  [nelem,nnode] = size(T); 
% numero de nodos total  
  npoin = size(X,1); 
% Numero de puntos de Gauss
  ngaus = 4;
%
% Determinacion de la cuadratura y funciones de forma
  [pospg,pespg] = Cuadratura(ngaus);
  [N,Nxi,Neta] = FuncForm(pospg);

% Dimensionamiento  
F = zeros(npoin,1); 

% bucle en elementos 
for ielem = 1:nelem 
    Te = T(ielem,:); 
    Xe = X(Te,:); % Xe: coordenadas de los nodos del elemento
    Fe=VectorCargaElCuadrilatero(Xe,nnode,pospg,pespg,N,Nxi,Neta);
    F(Te) = F(Te)+Fe; 
    clear fe; 
end 
 