function [N,Nxi,Neta] = FuncForm(pospg) 
% [N,Nxi,Neta] = FuncForm(pospg) 
% N, Nxi, Neta: matrices que almacenan los valores de las funciones de forma 
%               y derivadas (en coordenadas locales del elemento de referencia 
%               triangular) en los puntos de Gauss (cada punto de Gauss en una fila) 
% pospg:        posicin de los puntos de Gauss en el elemento de referencia 
 
xi = pospg(:,1); eta = pospg(:,2); 
N    = [1-xi-eta, xi, eta]; 
Nxi  = [-1, 1, 0;
        -1, 1, 0;
        -1, 1, 0]; 
Neta = [-1, 0, 1;
        -1, 0, 1;
        -1, 0, 1]; 
