function [Ke] = MatRigidezElTriang(Xe,nnode)
% [Ke,fe] = MatRigidezElTriang(Xe,nnode) 
% Matriz de rigidez/conductividad Ke  
% elementales para la ecuacin del calor en 2D, usando Elementos
% Triangulares con tres  nodos 
%
% Xe:           coordenadas de los nodos del elemento 
% nnode:        nmero de nodos del elemento 
% %%%%%%%%%%%%%%%%%%%   Rodolfo Gallo septiembre 2011
% Dimensionamiento   
%Ke = zeros(nnode,); 
% % numero de puntos de Gauss 
%   ngaus = size(pospg,1);
xe=Xe(:,1); % componete x de los nodos
ye=Xe(:,2); % componente y de los nodos
Jacob = [-xe(1)+xe(2)  -ye(1)+ye(2)
           -xe(1)+xe(3)  -ye(1)+ye(3)];
% gradiente de las funciones de forma       
gradN=[-1 1 0
       -1 0 1];
    
res = Jacob\gradN; % esto equivalente a Jacob^(-1)*gradN
f1 = res(1,:); % primera fila de res
f2 = res(2,:); 
Int=(f1'*f1 + f2'*f2)*det(Jacob)*0.5; % integral sobre el elemento de ref
Ke =  Int; % matriz elemental  
  
  
 