function [K]=MatRigidezTriang(X,T) 
% [K]=MatRigidezTriang(X,T)  
% Matriz de rigidez/conductividad K Kij^(e)=int(grad varfi_i.grad vafi_j) 
% para elementos triangulares con tres nodos
% para la ecuacin del calor en 2D  
%     X:        coordenadas nodales 
%     T:        conectividades (elementos) 
% %%%%%%%%%%%%%%%%%%%i   Rodolfo Gallo agosto 2011
 
 
% numero de elementos y numero de nodos en cada elemento 
[nelem,nnode] = size(T); 
% numero de nodos total  
npoin = size(X,1);  
% Dimensionamiento 
K = zeros(npoin,npoin);  
% bucle en elementos 
for ielem = 1:nelem
    Te = T(ielem,:); % topologia del elemento
    Xe = X(Te,:); % Xe: coordenadas de los nodos del elemento
    Ke = MatRigidezElTriang(Xe,nnode);
    K(Te,Te) = K(Te,Te)+Ke; % ensamble de la matriz elemental en K
    clear Ke;
end