% Programa principal 
% Resolucin de la ecuacin de Poisson en 2D
% -(U_xx+Uyy)=f(x), en un dominio rectangular [x1,x2]x[y1,y2]
% Con condiciones de frontera Dirichlet

%%% CONSTRUCCIN DE LA MALLA
%_______________________________________________________
% defieniendo los intevalos [x1,y1] y [x2,y2]
%x1=0;  x2=1; y1=0; y2=1; nx=4; ny=5;
x1=-1;  x2=1; y1=-1; y2=1; nx=40; ny=40;

[X,T,Front] = CreaMallaTriang(x1,x2,y1,y2,nx,ny); % Crea la malla del rectangulo
%_________________________________________________________________________
%%% CREA LA MATRIZ K DEL SISTEMA ( matriz de rigidez) Y EL VECTOR F DE
%%% CARGA
%_________________________________________________________________________
Krigidez=MatRigidezTriang(X,T);
K=Krigidez; % matriz del sistema
f='fuente';
F=VectorCargaTriang(X,T,f);
%_________________________________________________________________________
%%% CREA LA MATRIZ G DEL SISTEMA DE CONDICIONES DE FRONTERA Ga=g;
%_________________________________________________________________________
% Numero de condiciones de frontera
ncondfron=size(Front,1);
% Matriz con los nodos en la frontera de Dirichlet y el valor prescrito
 Xfron=X(Front,:);
 Vfron=SolExacta(Xfron);
%C=[Front,zeros(ncondfron,1)];
 C=[Front,Vfron];
% Numero de ecuaciones del sitema
neq=size(F,1);
% Matriz G del sistema Ga=g con las condiciones de frontera de Dirichlet
G=zeros(ncondfron,neq);
G(:,C(:,1))=eye(ncondfron);
%_________________________________________________________________________
%%% ENSAMBLE DE LAS CONDICIONES DE FRONTERA DICHLET EN LA MATRIZ K 
Ktot=[K,G';G zeros(ncondfron,ncondfron)]; % matriz total del sistema
%_________________________________________________________________________
%%% ENSAMBLE DE LAS CONDICIONES DE FRONTERA DICHLET EN LA MATRIZ F
%_________________________________________________________________________
b=C(:,2);% Matriz del termino independiente de las condiciones frontera.
Ftotal=[F;b]; 
%_________________________________________________________________________
%%% SOLUCIN DEL SISTEMA
Sol=Ktot\Ftotal;
Sol=Sol(1:neq);

%_________________________________________________________________________
%pause
%%% POSTPROCESO
% Dibujo de la temperatura (campo escalar)
  figure(1)
  clf
  DibujaSol(X,T,Sol)
  title('Solucin calculada con EF');
  color = caxis; 
  escala(color,2)

% Solucion sol exacta
  figure(2)
%  x = X(:,1); y = X(:,2); 
 % exacta = (x-1).*(y-1).*x.*y; 
 SolExac=SolExacta(X);
  %exacta=(x.^2-1).*(y.^2-1).*sin(x.^2+y.^2-0.5);
  DibujaSol(X,T,SolExac)
  title('Solucin exacta');
  error=SolExac-Sol;
  norm_infError = max(abs(error));
  normEner=sqrt(error'*K*error)
  
  % Graficas en superficies:
  figure(3)
  tri=delaunay(X(:,1),X(:,2));
  trisurf(tri,X(:,1),X(:,2),SolExac);
  title('Solucin analtica');

  figure(4)
  tri=delaunay(X(:,1),X(:,2));
  trisurf(tri,X(:,1),X(:,2),Sol);
  title('Solucin calculada con EF');
%_________________________________________________________________________

