function [Fe] = VectorCargaElTriang(Xe,nnode,f)
% [Fe] = VectorCargaElTriang(Xe,nnode) 
% vector de carga elemental o trmino independiente Fe (fuente) 
% para la ecuacin del calor en 2D  Uxx+Uyy=f(x,y)
% en una malla de elementos triangulares con tres nodos
% Xe:           coordenadas de los nodos del elemento 
% nnode:        nmero de nodos del elemento 
% f es la funcuion fuente declarada previamente en un archivo.m
% %%%%%%%%%%%%%%%%%%%   Rodolfo Gallo septiembre 2011
 % Dimensionamiento 
  Fe = zeros(nnode,1); 
% % numero de puntos de Gauss 
%   ngaus = size(pospg,1); 
xe=Xe(:,1); % componete x de los nodos
ye=Xe(:,2); % componente y de los nodos
Jacob = [-xe(1)+xe(2)  -ye(1)+ye(2)
           -xe(1)+xe(3)  -ye(1)+ye(3)]; % jacobiano 
M = [2 1 1
     1 2 1
     1 1 2];
fsombrero = feval(f,Xe); 
Fe=M*fsombrero*det(Jacob)/24;
 
