function [F] = VectorCargaTriang(X,T,f) 
% VectorCargaTrian(X,T) 
% vector de carga trmino independiente f (fuente) 
% para la ecuacin del calor en 2D  Uxx+Uyy=f(x,y)
%     X:        coordenadas nodales 
%     T:        conectividades (elementos) 
% f es la funcion fuente declarado prviamente como un archivo.m
% %%%%%%%%%%%%%%%%%%%   Rodolfo Gallo septiembre 2011
 
 
% numero de elementos y numero de nodos en cada elemento 
  [nelem,nnode] = size(T); 
% numero de nodos total  
  npoin = size(X,1); 
 
% Dimensionamiento 
   
  F = zeros(npoin,1); 
 
% bucle en elementos 
  for ielem = 1:nelem  
    Te = T(ielem,:); 
    Xe = X(Te,:); % Xe: coordenadas de los nodos del elemento
    Fe = VectorCargaElTriang(Xe,nnode,f); 
    F(Te) = F(Te)+Fe; 
    clear Fe; 
  end 